// Copyright (c) 2023 Byron Lathi

module rr_scheduler #(
    parameter N_INITIATORS = 2,
    parameter N_TARGETS = 2
)(
    input clk,
    input rst,

    input [0:N_INITIATORS-1] ini_req,
    output [0:N_INITIATORS-1] ini_en,

    output logic [$clog2(N_INITIATORS)-1:0] master_sel,
    output logic master_valid
);

// super dumb

always @(posedge clk or posedge rst) begin
    if (rst) begin
        master_sel <= '0;
        master_valid <= '0;
    end else begin
        master_sel <= '0;
        master_valid <= '0;
        for (int i = 0; i < N_INITIATORS; i++) begin
            if (ini_req[i]) begin
                master_sel <= i;
                master_valid <= '1;
            end
        end
    end
end

// assign ini_en[0] = ini_req[0];

// assign master_sel = 0;

// assign master_valid = ini_req[0];

endmodule