# AXI Crossbar

This AXI Crossbar is a naiive crossbar where 1 initiator can connect to one 
target at a time. Each slave port is equiped with a FIFO to queue
transactions while blocked.

The round robin scheduler will attempt to service each initiator once before
moving on to the next one.

The transaction from initiator to target back to initiator again must complete
before moving on to the next initiator.

The entire crossbar is synchonous, and shares a common clk and rst.

It uses the AXI4-Lite protocol

## Scheduler

The scheduler takes in all of the empty signals from the input FIFOs.
Every cycle, the scheduler looks at the empty signals and finds the first
non-empty fifo after the current one.

The way it does this is it takes the current initiator, creates a bit mask
of all the bits above it, ands that with the input bits, then sends that into
a priority encoder to get the first bit set above the current..
